=== debian/changelog ===
groonga (13.0.0+dfsg-3~deb12u1) bookworm; urgency=medium

  * Backport to bookworm
    - It fixes missing dependency to libjs-*. (#1036575)

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 25 Jun 2023 15:03:18 +0900

groonga (13.0.0+dfsg-3) unstable; urgency=medium

  * debian/control
    - Fix missing dependency to libjs-*. (Closes: #1036575)
      It creates broken symlinks for groonga-bin, groonga-doc.

 -- Kentaro Hayashi <kenhys@xdump.org>  Fri, 02 Jun 2023 13:12:53 +0900

groonga (13.0.0+dfsg-2) unstable; urgency=medium

  * debian/control
    - Remove dependency to obsolete pcre3 library. (Closes: #1000064)
    - Bump Standards-Version to 4.6.2. No other changes are required.
  * debian/patches/0011-Allow-with-pcre2-configure-option.patch
    - Add patch to detect pcre2.

 -- Kentaro Hayashi <kenhys@xdump.org>  Thu, 23 Feb 2023 15:42:17 +0900

groonga (13.0.0+dfsg-1) unstable; urgency=medium

  * New upstream version 13.0.0+dfsg

 -- Kentaro Hayashi <kenhys@xdump.org>  Thu, 09 Feb 2023 22:01:18 +0900

groonga (12.1.2+dfsg-1) unstable; urgency=medium

  * New upstream version 12.1.2
  * debian/control
    - Add missing dependency to libjs-bootstrap
    - Fix depends-on-obsolete-package: lsb-base
  * debian/patches/*
    - Refresh patch files to apply

 -- Kentaro Hayashi <kenhys@xdump.org>  Thu, 02 Feb 2023 20:11:29 +0900

groonga (12.1.1+dfsg-1) unstable; urgency=medium

  * New upstream version 12.1.1
  * debian/patches/0002-Remove-needless-groonga-keyring-postrm.patch
    debian/patches/0005-Use-python3-pydata-sphinx-theme.patch
    - Refresh patch files to apply

 -- Kentaro Hayashi <kenhys@xdump.org>  Tue, 10 Jan 2023 20:13:35 +0900

groonga (12.1.0+dfsg-2) unstable; urgency=medium

  * Source only upload for migration to testing

 -- Kentaro Hayashi <kenhys@xdump.org>  Thu, 08 Dec 2022 16:01:50 +0900

groonga (12.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 12.1.0+dfsg
  * debian/control
    debian/groonga-server-http.*
    - Add groonga-server-http package
  * debian/groonga-httpd.default
    debian/groonga-server-gqtp.default
    - Add missing default parameters.
  * debian/groonga-httpd.service
    debian/groonga-server-gqtp.service
    - Create /run/groonga in beforehand
  * debian/rules
    - Reset dfsg for new version
    - Drop needless patch for *.html

 -- Kentaro Hayashi <kenhys@xdump.org>  Sun, 04 Dec 2022 17:12:59 +0900

groonga (12.0.9+dfsg2-2) unstable; urgency=medium

  * debian/patches/0010-Use-_GNU_SOURCE-on-GNU-Hurd.patch
    debian/patches/0010-Use-_GNU_SOURCE-on-GNU-Hurd.patch
    - Add patch for GNU Hurd

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 19 Nov 2022 22:18:43 +0900

groonga (12.0.9+dfsg2-1) unstable; urgency=medium

  * debian/copyright
    - Exclude bundled jquery-ui, jquery-flot
  * debian/control
    - Add dependency to libjs-jquery-*
    - Bump Standards-Version to 4.6.1.
  * debian/groonga-bin.links
    - Use installed libjs-jquery-*

 -- Kentaro Hayashi <kenhys@xdump.org>  Fri, 18 Nov 2022 22:15:28 +0900

groonga (12.0.9+dfsg-1) unstable; urgency=medium

  * New upstream version 12.0.4
  * debian/gbp.conf
    - Use gbp.conf explicitly
  * debian/copyright
    - Exclude generated files
    - Update license information
  * debian/rules
    - Enable to build document
    - Suppress parallel build for documentation
  * debian/control
    - Update build dependency for generating Sphinx documentation
    - Add missing dependency to autoconf-archive for generating
      configure correctly
  * debian/watch
    - Enable to repack archive.
  * debian/patches/0006-Use-python3-pydata-sphinx-theme.patch
    debian/patches/0007-Do-not-use-unsupported-options-for-python3-pydata-sp.patch
    - Add patch to use python3-pydata-sphinx-theme 0.7.2
  * debian/*.lintian-overrides
    - Update pattern to ignore correctly.

 -- Kentaro Hayashi <kenhys@xdump.org>  Sat, 12 Nov 2022 23:10:01 +0900

groonga (12.0.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No source change upload to rebuild with debhelper 13.10.

 -- Michael Biebl <biebl@debian.org>  Sat, 15 Oct 2022 12:08:27 +0200
