=== debian/tests/control ===
Tests: build, status, dependency
Depends: libgroonga-dev, build-essential, pkg-config, groonga-httpd, curl, jq
