=== debian/watch ===
version=4
opts=\
  repack,\
  dversionmangle=auto,\
  repacksuffix=+dfsg,\
  pgpsigurlmangle=s/$/.asc/ \
  https://packages.groonga.org/source/@PACKAGE@/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
